<template>
  <div>
    <v-list-item>
      <v-list-item-content>
        <v-list-item-title class="title">
          <v-text-field
            v-model="currently_edited_flight_path.name"
            label="Route name"
          ></v-text-field>
          <v-btn depressed :height="20" @click="$emit('save-route')">Save</v-btn>
          <v-btn depressed :height="20" @click="$emit('modify-route')">Modify</v-btn>
          <v-btn depressed :height="20" @click="$emit('delete-route')">Delete</v-btn>
        </v-list-item-title>
      </v-list-item-content>
    </v-list-item>

    <v-expansion-panels focusable
    :value="focused_segment_index"
    @change="updateFocusedIndex">
      <v-expansion-panel
        v-bind:key="index"
        v-for="(segment, index) in currently_edited_flight_path.segments"
      >
        <v-expansion-panel-header>
          <span v-if="index == 0">Start point</span>
          <span v-else>Segment {{ index }}</span>
          <v-btn v-if="index == focused_segment_index"
          depressed
          :height="20"
          color="red"
          @click="removeSegment(index)">Delete</v-btn>
        </v-expansion-panel-header>
        <v-expansion-panel-content>
          <v-row>
            <v-simple-table>
              <template v-slot:default>
                <tbody>
                  <tr>
                    <td>Latitude</td>
                    <td>{{ segment.end_position.lat.toFixed(5) }}</td>
                  </tr>
                  <tr>
                    <td>Longitude</td>
                    <td>{{ segment.end_position.lng.toFixed(5) }}</td>
                  </tr>
                  <tr>
                    <td>Altitude</td>
                    <td>
                      <v-text-field
                        label="Altitude"
                        v-model="segment.altitude"
                        placeholder="Altitude"
                      ></v-text-field>
                    </td>
                  </tr>
                  <tr>
                    <td>Speed</td>
                    <td>
                      <v-text-field
                        label="Speed"
                        v-model="segment.ground_speed"
                        placeholder="Speed"
                      ></v-text-field>
                    </td>
                  </tr>
                  <tr>
                    <td>Camera</td>
                    <td>
                      <v-switch
                        v-model="segment.camera_on"
                        :label="segment.camera_on ? 'on' : 'off'"
                      ></v-switch>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </v-row>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import FlightRoute, { FlightRouteSegment } from "@/components/FlightRoute";

@Component({})
export default class CurrentlyEditedFlightPathAppBar extends Vue {
  @Prop() currently_edited_flight_path!: FlightRoute;

  @Prop() focused_segment_index!: number;

  updateFocusedIndex(index: Event) {
    this.$emit('focus-updated', index);
  }

  removeSegment(index: number) {
    this.$emit('remove-segment', index);
  }
}
</script>

<style scoped>
</style>
